package cin.jats.tests.gui;

import javax.swing.*;

import cin.jats.tests.util.UserJaTSVariable;

import java.awt.*;
import java.awt.event.*;
import java.util.Collection;
import java.util.Iterator;


/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* *************************************
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED
* for this machine, so Jigloo or this code cannot be used legally
* for any corporate or commercial purpose.
* *************************************
*/
/**
 *  <p>
 *
 *  Title: </p> <p>
 *
 *  Description: </p> <p>
 *
 *  Copyright: Copyright (c) 2002</p> <p>
 *
 *  Company: </p>
 *
 *@author     Gustavo Santos
 *@created    March 20, 2003
 *@version    1.0
 */

public class DialogEditVar extends JDialog {

    public static final int APPROVE_OPTION = 1;
    private int option = 0;
    private UserJaTSVariable variable;

    JPanel jPanel1 = new JPanel();
    JLabel jLabel1 = new JLabel();
    JLabel jLabel2 = new JLabel();
    JScrollPane jScrollPane1 = new JScrollPane();
    JTextArea jTextAreaVarValue = new JTextArea();
    JTextField jTextFieldVarName = new JTextField();
    JComboBox jComboBoxVarType = new JComboBox();
    JLabel jLabel3 = new JLabel();
    JButton jButtonOK = new JButton();
    JButton jButtonCancel = new JButton();


    /**
     *  Constructor for the DialogEditVar object
     *
     *@param  var  Description of the Parameter
     */
    public DialogEditVar(UserJaTSVariable var) {
        this();
        this.variable = var;
        this.jTextFieldVarName.setText(var.getJaTSVariableName());
        this.jComboBoxVarType.setSelectedItem(var.getJatsTypeString());
        this.jTextAreaVarValue.setText(var.getJaTSVariableValue());
    }


    /**
     *  Constructor for the DialogEditVar object
     */
    public DialogEditVar() {
        try {
            jbInit();
            Collection types = UserJaTSVariable.getAllJatsTypes();
            Iterator it = types.iterator();

            while(it.hasNext()) {
                this.jComboBoxVarType.addItem(it.next());
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    /**
     *  Description of the Method
     *
     *@exception  Exception  Description of the Exception
     */
    private void jbInit() throws Exception {
        jPanel1.setLayout(null);
        jLabel1.setText("Variable Name:");
        jLabel1.setBounds(new Rectangle(20, 16, 92, 27));
        jLabel2.setText("VariableType:");
        jLabel2.setBounds(new Rectangle(20, 48, 88, 25));
        jScrollPane1.setBounds(new Rectangle(23, 103, 315, 106));
        jTextFieldVarName.setBounds(new Rectangle(117, 20, 214, 22));
        jComboBoxVarType.setBounds(new Rectangle(116, 50, 214, 22));
        jLabel3.setText("Value:");
        jLabel3.setBounds(new Rectangle(22, 79, 108, 16));
        jButtonOK.setBounds(new Rectangle(71, 221, 87, 23));
        jButtonOK.setText("OK");
        jButtonOK.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    jButtonOK_actionPerformed(e);
                }
            });
        jButtonCancel.setBounds(new Rectangle(195, 221, 87, 23));
        jButtonCancel.setToolTipText("");
        jButtonCancel.setText("Cancel");
        jButtonCancel.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    jButtonCancel_actionPerformed(e);
                }
            });
        this.getContentPane().add(jPanel1, BorderLayout.CENTER);
        jPanel1.add(jLabel1, null);
        jPanel1.add(jTextFieldVarName, null);
        jPanel1.add(jLabel2, null);
        jPanel1.add(jComboBoxVarType, null);
        jPanel1.add(jLabel3, null);
        jPanel1.add(jScrollPane1, null);
        jPanel1.add(jButtonCancel, null);
        jPanel1.add(jButtonOK, null);
        jScrollPane1.getViewport().add(jTextAreaVarValue, null);
        this.setModal(true);
    }


    /**
     *@param  args  The command line arguments
     */
    public static void main(String[] args) {
        DialogEditVar d = new DialogEditVar();
        d.setSize(0, 300);
        d.show();
    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void jButtonOK_actionPerformed(ActionEvent e) {
        this.variable = new UserJaTSVariable(
                this.jComboBoxVarType.getSelectedItem().toString(),
                this.jTextFieldVarName.getText(),
                this.jTextAreaVarValue.getText());
        this.option = APPROVE_OPTION;
        this.dispose();
    }


    /**
     *  Gets the variable attribute of the DialogEditVar object
     *
     *@return    The variable value
     */
    public UserJaTSVariable getVariable() {
        return variable;
    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void jButtonCancel_actionPerformed(ActionEvent e) {
        this.dispose();
    }

    public int showDialog() {
        this.setBounds(200, 200, 380, 300);
        super.show();
        return option;
    }

}
