package cin.jats.tests.gui;

import javax.swing.*;
import javax.swing.border.BevelBorder;

import cin.jats.engine.parser.ParseException;
import cin.jats.engine.processor.Processor;

import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;



/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* *************************************
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED
* for this machine, so Jigloo or this code cannot be used legally
* for any corporate or commercial purpose.
* *************************************
*/
public class PanelMetaProg extends javax.swing.JPanel {

  	Processor metaJatsProcessor;
  	JFileChooser fileChooser;
    javax.swing.filechooser.FileFilter filter;
    
	JTextField jTextFieldMetaProg = new JTextField();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JButton jButtonLoad = new JButton();
  JPanel jPanel2 = new JPanel();
  JButton jButtonProcess = new JButton();
  JButton jButtonRun = new JButton();
  JButton jButtonProcRun = new JButton();
GridLayout gridLayout1 = new GridLayout(3, 1);
  JPanel jPanel3 = new JPanel();
  JPanel jPanel4 = new JPanel();
  private JLabel jLabelJatsIntallDir;
  private JPanel jPanelspace2;
  private JPanel jPanelspace1;
  private JButton jButtonJatsIntallDir;
  private JTextField jTextFieldJatsInstallDir;
  private JPanel jPanelJatsInstallDir;
  private JPanel jPanelMetaProg;
  JPanel jPanel5 = new JPanel();
  JLabel jLabelMetaProg = new JLabel();

	public PanelMetaProg() {
    try {
      jbInit();
      metaJatsProcessor = new Processor();
      fileChooser = JaTSTesterFrame.fileChooser;
      filter = new javax.swing.filechooser.FileFilter() {
          public boolean accept(File f) {
            return f.getName().endsWith(".jats")
                || f.isDirectory();
          }
          public String getDescription() {
            return "MetaJaTS Programs (*.jats)";
          }
       };
       jTextFieldJatsInstallDir.setText(System.getProperty("java.class.path"));
       //jTextFieldJatsInstallDir.setText(this.getClass().getProtectionDomain().getCodeSource().getLocation().getPath());
    }
    catch(Exception e) {
      e.printStackTrace();
    }
	}
  private void jbInit() throws Exception {
    jTextFieldMetaProg.setPreferredSize(new java.awt.Dimension(314, 21));
    jTextFieldMetaProg.setText("");
    this.setLayout(borderLayout1);
    jButtonLoad.setPreferredSize(new java.awt.Dimension(147, 21));
    jButtonLoad.setText("Load Meta Program");
    jButtonLoad.addActionListener(new PanelMetaProg_jButtonLoad_actionAdapter(this));
    jButtonProcess.setPreferredSize(new Dimension(117, 25));
    jButtonProcess.setText("Process");
    jButtonProcess.addActionListener(new PanelMetaProg_jButtonProcess_actionAdapter(this));
    jButtonRun.setPreferredSize(new Dimension(117, 25));
    jButtonRun.setText("Run");
    jButtonRun.addActionListener(new PanelMetaProg_jButtonRun_actionAdapter(this));
    jButtonProcRun.setText("Process and Run");
    jButtonProcRun.addActionListener(new PanelMetaProg_jButtonProcRun_actionAdapter(this));
    jPanel2.setLayout(gridLayout1);
    gridLayout1.setColumns(1);
    gridLayout1.setRows(3);
    jLabelMetaProg.setText("Meta Program:");
	GridLayout jPanel1Layout = new GridLayout(4, 1);
	jPanel1Layout.setRows(4);
	jPanel1.setLayout(jPanel1Layout);
    this.add(jPanel1, BorderLayout.NORTH);
    jPanel1.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED));
	{
		jPanelspace1 = new JPanel();
		jPanel1.add(jPanelspace1);
	}
	{
		jPanelMetaProg = new JPanel();
		FlowLayout jPanelMetaProgLayout = new FlowLayout();
		jPanelMetaProgLayout.setAlignment(FlowLayout.LEFT);
		jPanelMetaProg.setLayout(jPanelMetaProgLayout);
		jPanel1.add(jPanelMetaProg);
		jPanelMetaProg.add(jLabelMetaProg);
		jPanelMetaProg.add(jTextFieldMetaProg);
		jPanelMetaProg.add(jButtonLoad);
	}
	{
		jPanelJatsInstallDir = new JPanel();
		jPanel1.add(jPanelJatsInstallDir);
		FlowLayout jPanelJatsInstallDirLayout = new FlowLayout();
		jPanelJatsInstallDirLayout.setAlignment(FlowLayout.LEFT);
		jPanelJatsInstallDir.setLayout(jPanelJatsInstallDirLayout);
		{
			jLabelJatsIntallDir = new JLabel();
			jPanelJatsInstallDir.add(jLabelJatsIntallDir);
			jLabelJatsIntallDir.setText("JaTS Home Dir:");
		}
		{
			jTextFieldJatsInstallDir = new JTextField();
			jPanelJatsInstallDir.add(jTextFieldJatsInstallDir);
			jTextFieldJatsInstallDir.setPreferredSize(new java.awt.Dimension(312, 20));
		}
		{
			jButtonJatsIntallDir = new JButton();
			jPanelJatsInstallDir.add(jButtonJatsIntallDir);
			jButtonJatsIntallDir.setText("Change...");
			jButtonJatsIntallDir.setPreferredSize(new java.awt.Dimension(146, 21));
			jButtonJatsIntallDir.addActionListener(new PanelMetaProg_jButtonChangeJatsDir_actionAdapter(this));
		}
	}
	{
		jPanelspace2 = new JPanel();
		jPanel1.add(jPanelspace2);
	}
    this.add(jPanel2,  BorderLayout.CENTER);
    jPanel2.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED));
	FlowLayout jPanel5Layout = new FlowLayout();
	jPanel5.setLayout(jPanel5Layout);
    jPanel2.add(jPanel5, null);
    jPanel5.add(jButtonProcess);
    jPanel2.add(jPanel4, null);
    jPanel2.add(jPanel3);
    jPanel4.add(jButtonRun, null);
    jPanel3.add(jButtonProcRun, null);
  }

  void jButtonLoad_actionPerformed(ActionEvent e) {
      fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
      fileChooser.setFileFilter(this.filter);
      int returnVal = fileChooser.showOpenDialog(this);
      if (returnVal == JFileChooser.APPROVE_OPTION) {
          String fileName = fileChooser.getSelectedFile().getAbsolutePath();
          if (fileName != null && !"".equals(fileName)) {
        	  this.jTextFieldMetaProg.setText(fileName);
          }
      }
  }

  void jButtonProcess_actionPerformed(ActionEvent e) {
		String absolutePath = this.jTextFieldMetaProg.getText();
		String classPath = System.getProperty("java.class.path");
		try {
			metaJatsProcessor.processProgram(classPath, absolutePath);
			JaTSTesterFrame.printMessage(
					"******  SUCCESS!  *******", false);
			JaTSTesterFrame.printMessage(
					"Files were generated in:" + absolutePath.substring(0, absolutePath.lastIndexOf(File.separator)), false);
		} catch (IllegalArgumentException e1) {
			e1.printStackTrace();
			JaTSTesterFrame.printMessage(
					"******  Invalid argument!  *******", true);
		} catch (ParseException e1) {
			e1.printStackTrace();
			JaTSTesterFrame.printMessage(
					"******  Error while parsing files  *******", true);
		} catch (IOException e1) {
			e1.printStackTrace();
			JaTSTesterFrame.printMessage(
					"******  Execution error!  *******", true);
		} catch (RuntimeException e1) {
			e1.printStackTrace();
			JaTSTesterFrame.printMessage(
					"******  Execution error!  *******", true);			
		} catch (InterruptedException e1) {
			e1.printStackTrace();
			e1.printStackTrace();
			JaTSTesterFrame.printMessage(
					"******  Abnormal process interruption!  *******", true);
		}
	}

  void jButtonRun_actionPerformed(ActionEvent e) {
		String absolutePath = this.jTextFieldMetaProg.getText();
		String path = absolutePath.substring(0, absolutePath
				.lastIndexOf(File.separator));
		try {
			metaJatsProcessor.runProgram(jTextFieldJatsInstallDir.getText() + ";" + path);
			JaTSTesterFrame.printMessage(
					"******  SUCCESS!  *******", false);
			JaTSTesterFrame.printMessage(
					"Files were generated in:" + path, false);
		} catch (IOException e1) {
			e1.printStackTrace();
			JaTSTesterFrame.printMessage(
					"******  Execution error!  *******", true);
		} catch (InterruptedException e1) {
			e1.printStackTrace();
			JaTSTesterFrame.printMessage(
					"******  Abnormal process interruption!  *******", true);
		} catch (RuntimeException e1) {
			e1.printStackTrace();
			JaTSTesterFrame.printMessage(
					"******  Execution error!  *******", true);			
		}
	}

  void jButtonProcRun_actionPerformed(ActionEvent e) {
		String absolutePath = this.jTextFieldMetaProg.getText();
		String classPath = System.getProperty("java.class.path");
		String path = absolutePath.substring(0, absolutePath
				.lastIndexOf(File.separator));
		try {
			JaTSTesterFrame.printMessage(
					">> Processing...", false);
			metaJatsProcessor.processProgram(classPath, absolutePath);
			JaTSTesterFrame.printMessage(
					"******  Succefuly processed!  *******", false);
			JaTSTesterFrame.printMessage(
					">> Runing...", false);
			metaJatsProcessor.runProgram(jTextFieldJatsInstallDir.getText()
					+ ";" + path);
			JaTSTesterFrame.printMessage(
					"******  SUCCESS!  *******", false);
			JaTSTesterFrame.printMessage(
					">> Files were generated in:" + path, false);
		} catch (IllegalArgumentException e1) {
			e1.printStackTrace();
			JaTSTesterFrame.printMessage(
					"******  Invalid argument!  *******", true);
		} catch (ParseException e1) {
			e1.printStackTrace();
			JaTSTesterFrame.printMessage(
					"******  Error while parsing files  *******", true);
		} catch (IOException e1) {
			e1.printStackTrace();
			JaTSTesterFrame.printMessage(
					"******  Execution error!  *******", true);
		} catch (InterruptedException e1) {
			e1.printStackTrace();
			JaTSTesterFrame.printMessage(
					"******  Abnormal process interruption!  *******", true);
		} catch (RuntimeException e1) {
			e1.printStackTrace();
			JaTSTesterFrame.printMessage(
					"******  Execution error!  *******", true);			
		}
  }

	public void jButtonChangeJatsDir_actionPerformed(ActionEvent e) {
		fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		int returnVal = fileChooser.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			String fileName = fileChooser.getSelectedFile().getAbsolutePath();
			if (fileName != null && !"".equals(fileName)) {
				this.jTextFieldJatsInstallDir.setText(fileName);
			}
		}
	}

}

class PanelMetaProg_jButtonLoad_actionAdapter implements java.awt.event.ActionListener {
  PanelMetaProg adaptee;

  PanelMetaProg_jButtonLoad_actionAdapter(PanelMetaProg adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButtonLoad_actionPerformed(e);
  }
}

class PanelMetaProg_jButtonProcess_actionAdapter implements java.awt.event.ActionListener {
  PanelMetaProg adaptee;

  PanelMetaProg_jButtonProcess_actionAdapter(PanelMetaProg adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButtonProcess_actionPerformed(e);
  }
}

class PanelMetaProg_jButtonRun_actionAdapter implements java.awt.event.ActionListener {
  PanelMetaProg adaptee;

  PanelMetaProg_jButtonRun_actionAdapter(PanelMetaProg adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButtonRun_actionPerformed(e);
  }
}

class PanelMetaProg_jButtonProcRun_actionAdapter implements java.awt.event.ActionListener {
  PanelMetaProg adaptee;

  PanelMetaProg_jButtonProcRun_actionAdapter(PanelMetaProg adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButtonProcRun_actionPerformed(e);
  }
}

class PanelMetaProg_jButtonChangeJatsDir_actionAdapter implements java.awt.event.ActionListener {
	  PanelMetaProg adaptee;

	  PanelMetaProg_jButtonChangeJatsDir_actionAdapter(PanelMetaProg adaptee) {
	    this.adaptee = adaptee;
	  }
	  public void actionPerformed(ActionEvent e) {
	    adaptee.jButtonChangeJatsDir_actionPerformed(e);
	  }
	}



