package cin.jats.engine.analyser;

import cin.jats.engine.parser.nodes.INode;
import cin.jats.engine.parser.nodes.JName;

public class Analyser {

	private Analyser() {
	}
	
	public static INode getDeclaration(INode variable) {
		
		if (!(variable instanceof JName)) {
			throw new IllegalArgumentException(
					"Can't retrieve declaration for " + variable.getClass()
							+ " nodes");
		}
		JName var = (JName)variable;
		return var.getDeclarationRef();
	}

}
