/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.parser.nodes;

/**
 * Esta interface representa uma declarao, que pode ser de atributo, de
 * mtodo, de contrutor ou de importao. Ela ainda no possui mtodos, nem
 * atributos e, por enquanto, serve apenas para uniformizar o tratamento das
 * declaraes.
 * 
 * @author Adeline de Sousa
 * @version 18/07/2002
 */

public interface Declaration extends JaTSNode {

    // retorna a assiantura desta declarao
    public Signature getSignature();

//    public AttributeSectionList getAttributes();

//    public void setAttributes(AttributeSectionList att);


}
