/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.parser.nodes;

/**
 * Esta interface  vazia e serve apenas para indicar
 * um membro de uma interface. Ou seja: sera implementada apenas por
 * JMethodDeclaration e JFieldDeclaration
 */
public interface InterfaceMember {

    /**
     * Retorna a assintatura do Membro da Interface
     *
     * @return Assinatura deste membro
     */
    public Signature getSignature();

    /**
     * Retorna o tipo do mebmbro
     *
     * @return Tipo do membro
     */
    public JType getMemberType();

}


