/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.parser.nodes.metajats;

public class ApplyExpression {

	private String sourceId;
	private String transfId;
	private String rSetId;
	
	/**
	 * @param id
	 * @param id2
	 * @param id3
	 */
	public ApplyExpression(String sourceId, String transfId, String rSetId) {
		this.sourceId = sourceId;
		this.transfId = transfId;
		this.rSetId = rSetId;
	}

	public ApplyExpression() {
	}

	/**
	 * @return Returns the rSetId.
	 */
	public String getRSetId() {
		return rSetId;
	}

	/**
	 * @param setId The rSetId to set.
	 */
	public void setRSetId(String setId) {
		rSetId = setId;
	}

	/**
	 * @return Returns the sourceId.
	 */
	public String getSourceId() {
		return sourceId;
	}

	/**
	 * @param sourceId The sourceId to set.
	 */
	public void setSourceId(String sourceId) {
		this.sourceId = sourceId;
	}

	/**
	 * @return Returns the transfId.
	 */
	public String getTransfId() {
		return transfId;
	}

	/**
	 * @param transfId The transfId to set.
	 */
	public void setTransfId(String transfId) {
		this.transfId = transfId;
	}

}
