/*
 * JaTS Project - Java Transformation System
 * http://www.cin.ufpe.br/~jats
 *  
 * Copyright  2005  Informatics Center - Federal University of Pernambuco
 * 
 * JaTS is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 */
package cin.jats.engine.printing;

/**
 * Interface que define as constantes utilizadas para buscar as propriedades
 * do PrettyPrintter no arquivo de configurao
 *
 * @author Adeline de Sousa
 * @version 22/10/2002
 */
public interface PrettyProperties {

    String BLOCK_INDENT = "BLOCK_INDENT";

    String CLASS_DESCRIPTION = "CLASS_DESCRIPTION";

    String INTERFACE_DESCRIPTION = "INTERFACE_DESCRIPTION";

    String METHOD_DESCRIPTION = "METHOD_DESCRIPTION";

    String GET_DESCRIPTION = "GET_DESCRIPTION";

    String SET_DESCRIPTION = "SET_DESCRIPTION";

    String CONSTRUCTOR_DESCRIPTION = "CONSTRUCTOR_DESCRIPTION";

    String PARAMETER_DESCRIPTION = "PARAMETER_DESCRIPTION";

    String EXCEPTION_DESCRIPTION = "EXCEPTION_DESCRIPTION";

    String RETURN_DESCRIPTION = "RETURN_DESCRIPTION";

    String DATE_FORMAT = "DATE_FORMAT";

    String INDENT_SIZE = "INDENT_SIZE";


}
