package cin.jats.tests.gui;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.io.*;
import java.util.Vector;
import cin.jats.engine.parser.ParseException;
import cin.jats.engine.parser.nodes.ICompilationUnit;
import cin.jats.tests.JaTSTester;


/**
 *  <p>
 *  Title: </p> <p>
 *  Description: </p> <p>
 *  Copyright: Copyright (c) 2002</p> <p>
 *  Company: </p>
 *
 *@author     unascribed
 *@created    10 de Junho de 2002
 *@version    1.0
 */

public class JaTSTesterFrame extends JFrame {

	// Reference to the JaTSTester
    JaTSTester jaTSTester;

    // Path to the properties File
    static String propertiesFilePath;

    static int rsetDebugFileNumber;

    public static String TEMPLATES_PATH;
    Vector parseFiles = new Vector();

    public static JFileChooser fileChooser;
    static javax.swing.filechooser.FileFilter filter;
    {
      TEMPLATES_PATH = System.getProperty("user.dir");
      fileChooser = new JFileChooser(TEMPLATES_PATH);
      filter = new javax.swing.filechooser.FileFilter() {
              public boolean accept(File f) {
                return f.getName().endsWith(".jtp") || f.isDirectory();
              }
              public String getDescription() {
                return "JaTSTester Properties (*.jtp)";
              }
            };
      fileChooser.setFileFilter(filter);
    }

    JScrollPane jScrollPaneTxtArea = new JScrollPane();
    static JTextArea txtAreaOutput = new JTextArea(5, 0);
    JPanel panelMain = new JPanel();
    JPanel panelMain2 = new JPanel();

    BorderLayout borderLayout1 = new BorderLayout();
    MenuBar menuBarJaTSTester = new MenuBar();
    Menu menuFile = new Menu();
    MenuItem mItemLoadProperties = new MenuItem();
    MenuItem mItemReloadProperties = new MenuItem();
    Menu menuOutput = new Menu();
    MenuItem mItemGenerateRsetFile = new MenuItem();
    MenuItem mItemExit = new MenuItem();
    JLabel lblDirFiles = new JLabel();
    JLabel lblApplyFile = new JLabel();
//    JLabel lblWizardName = new JLabel();
//    JLabel lblSourceJar = new JLabel();
    JScrollPane jScrollPaneJavaSource = new JScrollPane();
    JList jListJavaSource = new JList();
    JList jListRightTemplates = new JList();
    JList jListLeftTemplates = new JList();
    JScrollPane jScrollPaneRightTemplates = new JScrollPane();
    JScrollPane jScrollPaneLeftTemplates = new JScrollPane();
    JLabel lblLeftTemplates = new JLabel();
    JLabel lblRightTemplates = new JLabel();
    JLabel lblJavaSource = new JLabel();
    JLabel lblPropertiesFile = new JLabel();
    JButton bthClearArea = new JButton();
    JPanel panelConfButtons = new JPanel();
    TitledBorder titledBorder1;
    JCheckBox chkRightTemplate = new JCheckBox();
    JCheckBox chkSourceFiles = new JCheckBox();
    JCheckBox chkLeftTemplate = new JCheckBox();
//    JCheckBox chkTemplateFromJar = new JCheckBox();
//    JCheckBox chkSourceFromJar = new JCheckBox();
    JButton btnParsing = new JButton();
    JButton btnApply = new JButton();
    JButton btnMatching = new JButton();
    GridLayout gridLayout1 = new GridLayout(3, 1); //panel configuration
    JList jList1 = new JList();
    JButton jButton1 = new JButton();
    JButton jButton2 = new JButton();
    JScrollPane jScrollPane1 = new JScrollPane();
    JPanel jPanelActions2 = new JPanel();
    TitledBorder titledBorder2;
    JButton jButtonParseAll = new JButton();
    JPanel jPanelActions = new JPanel();
    TitledBorder titledBorder3;
    GridLayout gridLayout2 = new GridLayout(4, 1); //panel actions 1
    GridLayout gridLayout3 = new GridLayout(3, 1); //panel actions 2
    Menu menu1 = new Menu();
    MenuItem menuItemParsingTest = new MenuItem();
    MenuItem menuItemGenerationTest = new MenuItem();
    MenuItem menuItemEditProp = new MenuItem();
    PanelEditProperties panelEditProperties1 = new PanelEditProperties();
    PanelMetaProg panelMetaProg = new PanelMetaProg();
    MenuItem menuItem1 = new MenuItem();


    /**
     *  Constructor for the JaTSTesterFrame object
     */
    public JaTSTesterFrame() {
        try {
            jbInit();
            jaTSTester = new JaTSTester();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    /**
     *  The main program for the JaTSTesterFrame class
     *
     *@param  args  The command line arguments
     */
    public static void main(String[] args) {
        JaTSTesterFrame jaTSTesterFrame = new JaTSTesterFrame();
        jaTSTesterFrame.setSize(820, 430);
        jaTSTesterFrame.centerFrame();
        jaTSTesterFrame.show();
    }


    /**
     *  Description of the Method
     *
     *@exception  Exception  Description of the Exception
     */
    private void jbInit() throws Exception {
        titledBorder2 = new TitledBorder("");
        titledBorder3 = new TitledBorder("");
        jButton1.setBounds(new Rectangle(414, 38, 141, 29));
        jButton1.setText("Add templates...");
        jButton2.setBounds(new Rectangle(414, 76, 141, 29));
        jButton2.setText("Remove templates");
        panelMain2.setLayout(null);
        jScrollPane1.setBounds(new Rectangle(20, 39, 374, 203));
        jPanelActions2.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(148, 145, 140)), "Actions :"));
        jPanelActions2.setBounds(new Rectangle(587, 32, 179, 141));
        jPanelActions2.setLayout(gridLayout3);
        jButtonParseAll.setMaximumSize(new Dimension(200, 27));
        jButtonParseAll.setPreferredSize(new Dimension(110, 27));
        jButtonParseAll.setText("Test Parsing");
        jPanelActions.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(148, 145, 140)), "Actions :"));
        jPanelActions.setBounds(new Rectangle(597, 153, 192, 137));
        jPanelActions.setLayout(gridLayout2);
        menu1.setLabel("Modes");
        menuItemParsingTest.setLabel("Parsing Test");
        menuItemGenerationTest.setLabel("Transformation Test");
        menuItemEditProp.setLabel("Edit Properties File");
    menuItemEditProp.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        menuItemEditProp_actionPerformed(e);
      }
    });
    menuItemEditProp.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        menuItemEditProp_actionPerformed(e);
      }
    });
        gridLayout2.setRows(3);
    menuItem1.setLabel("Meta Program Test");
    menuItem1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        menuItem1_actionPerformed(e);
      }
    });
    panelMain2.add(jScrollPane1, null);
        panelMain2.add(jButton2);
        panelMain2.add(jButton1);
        panelMain2.add(jPanelActions2, null);
        jPanelActions2.add(jButtonParseAll, null);
        jScrollPane1.getViewport().add(jList1, null);
        titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(148, 145, 140)), "Configuration :");
        this.setTitle("JaTSTester");
        panelMain.setLayout(null);

        txtAreaOutput.setEditable(false);
        lblDirFiles.setText("Files Directory : ");
        lblJavaSource.setText("Java Surce Files :");
        lblLeftTemplates.setText("Left Templates :");
        lblRightTemplates.setText("Right Templates :");
        lblPropertiesFile.setText("Properties File :");
        lblApplyFile.setText("Output Directory : ");
//        lblWizardName.setText("Wizard Jar Name : ");
//        lblSourceJar.setText("Java Source Jar name : ");

        jScrollPaneJavaSource.setAutoscrolls(true);
        jScrollPaneRightTemplates.setAutoscrolls(true);
        jScrollPaneLeftTemplates.setAutoscrolls(true);
        jScrollPaneLeftTemplates.setBounds(new Rectangle(15, 155, 175, 135));
        jScrollPaneJavaSource.setBounds(new Rectangle(205, 155, 175, 135));
        jScrollPaneRightTemplates.setBounds(new Rectangle(395, 155, 175, 135));

        lblPropertiesFile.setBounds(new Rectangle(20, 15, 550, 20));
        lblDirFiles.setBounds(new Rectangle(20, 35, 550, 20));
        lblApplyFile.setBounds(new Rectangle(20, 55, 548, 20));
//        lblWizardName.setBounds(new Rectangle(20, 75, 480, 20));
//        lblSourceJar.setBounds(new Rectangle(20, 95, 356, 20));

        lblLeftTemplates.setBounds(new Rectangle(15, 135, 100, 20));
        lblJavaSource.setBounds(new Rectangle(205, 135, 100, 20));
        lblRightTemplates.setBounds(new Rectangle(395, 135, 100, 20));

        bthClearArea.setBounds(new Rectangle(15, 91, 175, 25));
        bthClearArea.setText("Clear Log Area");
        panelConfButtons.setBorder(titledBorder1);
        panelConfButtons.setBounds(new Rectangle(597, 9, 192, 141));
        panelConfButtons.setLayout(gridLayout1);
        chkRightTemplate.setText("Use Right Template Files");
        chkSourceFiles.setText("Use Java Source Files");
        chkLeftTemplate.setText("Use Left Template Files");
        chkRightTemplate.setSelected(true);
        chkSourceFiles.setSelected(true);
        chkLeftTemplate.setSelected(true);
//        chkTemplateFromJar.setText("Read Template from Jar");
//        chkSourceFromJar.setText("Read Source from Jar");
        btnParsing.setText("Test Template Parsing");
        btnMatching.setText("Test Template Matching");
        this.getContentPane().add(jScrollPaneTxtArea, BorderLayout.SOUTH);
        this.getContentPane().add(panelMain, BorderLayout.CENTER);
        panelMain.add(jScrollPaneLeftTemplates, null);
        panelMain.add(jScrollPaneRightTemplates, null);
        panelMain.add(jScrollPaneJavaSource, null);
        jScrollPaneJavaSource.getViewport().add(jListJavaSource, null);
        jScrollPaneRightTemplates.getViewport().add(jListRightTemplates, null);
        jScrollPaneLeftTemplates.getViewport().add(jListLeftTemplates, null);

        jScrollPaneTxtArea.getViewport().add(txtAreaOutput, null);
        panelMain.add(lblRightTemplates, null);
        panelMain.add(lblLeftTemplates, null);
        panelMain.add(lblJavaSource, null);
        panelMain.add(lblDirFiles, null);
        panelMain.add(lblApplyFile, null);
//        panelMain.add(lblWizardName, null);
//        panelMain.add(lblSourceJar, null);
        panelMain.add(lblPropertiesFile, null);
        panelMain.add(panelConfButtons, null);

//        panelConfButtons.add(chkTemplateFromJar, null);
//        panelConfButtons.add(chkSourceFromJar, null);
        panelConfButtons.add(chkLeftTemplate, null);
        panelConfButtons.add(chkSourceFiles, null);
        panelConfButtons.add(chkRightTemplate, null);
        panelMain.add(bthClearArea, null);
        panelMain.add(jPanelActions, null);
        jPanelActions.add(btnParsing, null);
        jPanelActions.add(btnMatching, null);
        jPanelActions.add(btnApply, null);

        jScrollPaneTxtArea.setAutoscrolls(true);

        createAdapters();
        configMenuBar();

        menuBarJaTSTester.add(menuFile);
        menuBarJaTSTester.add(menuOutput);
        menuBarJaTSTester.add(menu1);
        menu1.add(menuItemParsingTest);
        menu1.add(menuItemGenerationTest);
        menu1.add(menuItemEditProp);
    menu1.add(menuItem1);

        this.setMenuBar(menuBarJaTSTester);

        this.panelEditProperties1.setTextArea(txtAreaOutput);
    }


    /**
     *  Description of the Method
     */
    private void configMenuBar() {
        menuFile.setLabel("File");
        menuOutput.setLabel("Output Files");
        mItemGenerateRsetFile.setLabel("Generate ResultSet File of last operation");
        mItemExit.setLabel("Exit");

        menuFile.add(mItemLoadProperties);
        menuFile.add(mItemReloadProperties);
        menuFile.addSeparator();
        menuFile.add(mItemExit);
        menuOutput.add(mItemGenerateRsetFile);
    }


    /**
     *  Description of the Method
     */
    private void createAdapters() {
        this.addWindowListener(
            new java.awt.event.WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    this_windowClosing(e);
                }
            });
        btnApply.setText("Test Transformation");
        mItemLoadProperties.setLabel("Load Properties File ...");
        mItemLoadProperties.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    mItemLoadProperties_actionPerformed(e);
                }
            });

        mItemReloadProperties.setLabel("Reload File ...");
        mItemReloadProperties.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    mItemReloadProperties_actionPerformed(e);
                }
            });

        mItemGenerateRsetFile.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    mItemGenerateRsetFile_actionPerformed(e);
                }
            });

        mItemExit.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    mItemExit_actionPerformed(e);
                }
            });
        bthClearArea.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    bthClearArea_actionPerformed(e);
                }
            });
        btnParsing.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    btnParsing_actionPerformed(e);
                }
            });
        btnApply.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    btnApply_actionPerformed(e);
                }
            });
        btnMatching.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    btnMatching_actionPerformed(e);
                }
            });
        jButton1.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    jButton1_actionPerformed(e);
                }
            });
        jButton2.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    jButton2_actionPerformed(e);
                }
            });
        jButtonParseAll.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    jButtonParseAll_actionPerformed(e);
                }
            });
        menuItemParsingTest.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    menuItemParsingTest_actionPerformed(e);
                }
            });
        menuItemGenerationTest.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    menuItemGenerationTest_actionPerformed(e);
                }
            });

    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void mItemLoadProperties_actionPerformed(ActionEvent e) {
        FileInputStream fis = null;
        try {
            fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
            fileChooser.setFileFilter(filter);
            int returnVal = fileChooser.showOpenDialog(this);
            if (returnVal == JFileChooser.APPROVE_OPTION) {
                String fileName = fileChooser.getSelectedFile().getAbsolutePath();
                if (fileName != null && !"".equals(fileName)) {
                    propertiesFilePath = fileName;
                    fis = new FileInputStream(fileName);
                    this.jaTSTester.loadJaTSTesterProperties(fis);
                    refreshComponentsSettings();
                }
            }
        } catch (Exception ex) {
            handleExceptions(ex);
        } finally {
            try {
                if (fis != null) {
                    fis.close();
                }
            } catch (Exception iox) {}
        }
    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void mItemReloadProperties_actionPerformed(ActionEvent e) {
        try {
            FileInputStream fis = new FileInputStream(propertiesFilePath);
            this.jaTSTester.loadJaTSTesterProperties(fis);
            refreshComponentsSettings();
        } catch (Exception ex) {
            handleExceptions(ex);
        }
    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void mItemExit_actionPerformed(ActionEvent e) {
        this.dispose();
    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void btnParsing_actionPerformed(ActionEvent e) {
        String parsingItem = "";
        boolean atLeastOneSelected = false;
        try {
            this.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            if (jaTSTester.isIsValidPropertyFile()) {
                if (chkLeftTemplate.isSelected()) {
                    Object[] values = jListLeftTemplates.getSelectedValues();
                    int length = values.length;
                    if (length > 0) {
                        for (int i = 0; i < length; i++) {
                            parsingItem = (String) values[i];
                            jaTSTester.parseTemplateFile(parsingItem,
                                    false);//chkTemplateFromJar.isSelected());
                        }
                        atLeastOneSelected = true;
                    }
                }
                if (chkSourceFiles.isSelected()) {
                    Object[] values = jListJavaSource.getSelectedValues();
                    int length = values.length;
                    if (length > 0) {
                        for (int i = 0; i < length; i++) {
                            parsingItem = (String) values[i];
                            jaTSTester.parseSourceFile(parsingItem,
                                    false);//chkSourceFromJar.isSelected());
                        }
                        atLeastOneSelected = true;
                    }
                }
                if (chkRightTemplate.isSelected()) {
                    Object[] values = jListRightTemplates.getSelectedValues();
                    int length = values.length;
                    if (length > 0) {
                        for (int i = 0; i < length; i++) {
                            parsingItem = (String) values[i];
                            jaTSTester.parseTemplateFile(parsingItem,
                                    false);//chkTemplateFromJar.isSelected());
                        }
                        atLeastOneSelected = true;
                    }
                }
                if (!atLeastOneSelected) {
                    printMessage("******  Select at list one file to be parsed !  *******", true);
                } else {
                    printMessage("******  File(s) parsed successfully !  *******", true);
                }
            } else {
                printMessage("******  Load a valid property file first !  *******", true);
            }
        } catch (ParseException ex) {
            printMessage("Error parsing the following file : " + "\"" + parsingItem + "\"", true);
            handleExceptions(ex);
        } catch (Exception ex) {
            handleExceptions(ex);
        } finally {
            this.setCursor(null);
        }
    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void btnMatching_actionPerformed(ActionEvent e) {
        try {
            this.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            if (jaTSTester.isIsValidPropertyFile()) {
                jaTSTester.testTemplateMatching(false,false);//chkSourceFromJar.isSelected(),
                        //chkTemplateFromJar.isSelected());
                printMessage("..............  Matching Successful !! ...............", false);
            } else {
                printMessage("******  Load a valid property file first !  *******", true);
            }
        } catch (Exception ex) {
            handleExceptions(ex);
        } finally {
            this.setCursor(null);
        }
    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void btnApply_actionPerformed(ActionEvent e) {
        try {
            this.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            if (jaTSTester.isIsValidPropertyFile()) {
                jaTSTester.testEngineApply(false, false);//chkSourceFromJar.isSelected(),
                        //chkTemplateFromJar.isSelected());
                printMessage("..............  Apply Successful !! ...............", false);
                printMessage("Files were created in the following directory: " +
                        jaTSTester.getOutputDirectory(), false);
            } else {
                printMessage("******  Load a valid property file first !  *******", true);
            }
        } catch (Exception ex) {
            handleExceptions(ex);
        } finally {
            this.setCursor(null);
        }
    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void mItemGenerateRsetFile_actionPerformed(ActionEvent e) {
        try {
            if (jaTSTester.isIsValidPropertyFile()) {
                String rsetDebug = jaTSTester.resultSetDebugString();
                String fileName = jaTSTester.getFilesDirectory() + "\\" + "rsetDebug" +
                        rsetDebugFileNumber + ".txt";
                jaTSTester.writeStringToFile(fileName, rsetDebug);
                ++rsetDebugFileNumber;
                printMessage(" The following debug file was created : " + fileName, false);
            } else {
                printMessage("******  Load a valid property file first !  *******", true);
            }
        } catch (Exception ex) {
            handleExceptions(ex);
        }
    }


    /**
     *  Description of the Method
     */
    private void refreshComponentsSettings() {
        lblDirFiles.setText("Files Directory : " + jaTSTester.getFilesDirectory());
        lblApplyFile.setText("Output Directory : " + jaTSTester.getOutputDirectory());
//        lblSourceJar.setText("Java Source Jar name : " + jaTSTester.getSourceJarFileName());
//        lblWizardName.setText("Wizard Jar Name : " + jaTSTester.getWizardJarFileName());
        lblPropertiesFile.setText("Properties File : " +
                                  this.propertiesFilePath.substring(
                                  this.propertiesFilePath.lastIndexOf("\\")+1,
                                  this.propertiesFilePath.length()));
        fillElementsList();
        printMessage("Properties refreshed ......", false);
    }


    /**
     *  Description of the Method
     */
    private void fillElementsList() {
        jListLeftTemplates.setListData(new Object[0]);
        jListJavaSource.setListData(new Object[0]);
        jListRightTemplates.setListData(new Object[0]);
        jListLeftTemplates.setListData(jaTSTester.getTemplateLeftNames());
        jListJavaSource.setListData(jaTSTester.getSourceNames());
        jListRightTemplates.setListData(jaTSTester.getTemplateRightNames());
    }


    /**
     *  Centers the frame in the middle of the screen
     */
    public void centerFrame() {
        //Center the window
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = this.getSize();
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    private void handleExceptions(Throwable e) {
        String temp = txtAreaOutput.getText();
        txtAreaOutput.setCaretColor(Color.red);
        txtAreaOutput.setText(temp + e.toString() + "\n");
        e.printStackTrace();
    }


    /**
     *  Description of the Method
     *
     *@param  msg        Description of the Parameter
     *@param  isWarning  Description of the Parameter
     */
    protected static void printMessage(String msg, boolean isWarning) {
        if (isWarning) {
            txtAreaOutput.setCaretColor(Color.red);
        } else {
            txtAreaOutput.setCaretColor(Color.black);
        }
        txtAreaOutput.append(msg + "\n");
    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void bthClearArea_actionPerformed(ActionEvent e) {
        txtAreaOutput.setText("");
    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void this_windowClosing(WindowEvent e) {
        System.exit(1);
    }

    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void jButton1_actionPerformed(ActionEvent e) {
        //JFileChooser chooser = new JFileChooser(this.TEMPLATES_PATH);
        fileChooser.setMultiSelectionEnabled(true);
        int ret = fileChooser.showOpenDialog(this);
        if (ret == JFileChooser.APPROVE_OPTION) {
            File[] files = fileChooser.getSelectedFiles();

            for (int i = 0; i < files.length; i++) {
                if (!parseFiles.contains(files[i])) {
                    parseFiles.add(files[i]);
                }
            }

            this.jList1.setListData(this.parseFiles);
        }
    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void jButtonParseAll_actionPerformed(ActionEvent e) {
        Object[] values = null;

        if (this.jList1.isSelectionEmpty()) {
            int size = this.jList1.getModel().getSize();
            values = new Object[size];
            for (int i = 0; i < size; i++) {
                values[i] = this.jList1.getModel().getElementAt(i);
            }

        } else {
            values = this.jList1.getSelectedValues();
        }

        try {
            for (int i = 0; i < values.length; i++) {
                jaTSTester.parseTemplateFile("" + values[i], false);
            }
            printMessage("******  File(s) parsed successfully !  *******", true);
        } catch (Exception exc) {
            exc.printStackTrace();
        }

    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void jButton2_actionPerformed(ActionEvent e) {
        Object[] values = this.jList1.getSelectedValues();

        if (values != null && values.length > 0) {

            for (int i = 0; i < values.length; i++) {
                this.parseFiles.remove(values[i]);
            }

            this.jList1.setListData(this.parseFiles);
        }
    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
/*    void unmatchedVar_actionPerformed(ActionEvent e) {
        String parsingItem = "";
        ICompilationUnit[] compsRight = null;
        ICompilationUnit[] compsLeft = null;
        try {
            this.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            if (jaTSTester.isIsValidPropertyFile()) {
                int length = jListLeftTemplates.getModel().getSize();
                if (length > 0) {
                    compsLeft = new cin.jats.engine.parser.nodes.JCompilationUnit[length];
                    for (int i = 0; i < length; i++) {
                        parsingItem = jListLeftTemplates.getModel().
                                getElementAt(i).toString();
                        compsLeft[i] = (ICompilationUnit) jaTSTester.parseTemplateFile(parsingItem,
                                false);//chkTemplateFromJar.isSelected());
                    }
                }
                Object[] values = jListRightTemplates.getSelectedValues();
                length = jListRightTemplates.getModel().getSize();
                if (length > 0) {
                    compsRight = new cin.jats.engine.parser.nodes.JCompilationUnit[length];
                    for (int i = 0; i < length; i++) {
                        parsingItem = jListRightTemplates.getModel().
                                getElementAt(i).toString();
                        compsRight[i] = (ICompilationUnit) jaTSTester.parseTemplateFile(parsingItem,
                                false);//chkTemplateFromJar.isSelected());
                    }
                }
            } else {
                printMessage("******  Load a valid property file first !  *******", true);
            }

            Vector totalLeft = new Vector();
            Vector totalRight = new Vector();
            Vector unmatched = new Vector();

            cin.jats.engine.util.NodeList list = null;
            Vector temp = null;
            for (int i = 0; i < compsLeft.length; i++) {
                temp = compsLeft[i].getTable().getTable();
                for (int j = 0; j < temp.size(); j++) {
                    list = (cin.jats.engine.util.NodeList) temp.elementAt(j);
                    totalLeft.addAll(list.getElements());
                }
            }
            for (int i = 0; i < compsRight.length; i++) {
                temp = compsRight[i].getTable().getTable();
                for (int j = 0; j < temp.size(); j++) {
                    list = (cin.jats.engine.util.NodeList) temp.elementAt(j);
                    totalRight.addAll(list.getElements());
                }
            }

            java.util.Iterator it = totalRight.iterator();

            while (it.hasNext()) {
                cin.jats.engine.parser.nodes.JaTSNode no =
                        (cin.jats.engine.parser.nodes.JaTSNode) it.next();
                if (!totalLeft.contains(no)) {
                    unmatched.add(no);
                }
            }

            printMessage("\n***********  Variaveis que constam apenas no lado direito *********\n", false);
            for (int i = 0; i < unmatched.size(); i++) {
                if (((cin.jats.engine.parser.nodes.JaTSNode) unmatched.elementAt(i)).isVariable()) {
                    printMessage(((cin.jats.engine.parser.nodes.JaTSNode)
                            unmatched.elementAt(i)) + "", false);
                }
            }

        } catch (ParseException ex) {
            printMessage("Error parsing the following file : " + "\"" + parsingItem + "\"", true);
            handleExceptions(ex);
        } catch (Exception ex) {
            handleExceptions(ex);
        } finally {
            this.setCursor(null);
        }
    }
*/

    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void menuItemParsingTest_actionPerformed(ActionEvent e) {
        this.getContentPane().removeAll();
        this.getContentPane().add(this.panelMain2, BorderLayout.CENTER);
        this.getContentPane().add(this.jScrollPaneTxtArea, BorderLayout.SOUTH);
        this.getContentPane().repaint();
        this.repaint();
        this.setVisible(true);
    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void menuItemGenerationTest_actionPerformed(ActionEvent e) {
        this.getContentPane().removeAll();
        this.getContentPane().add(this.panelMain, BorderLayout.CENTER);
        this.getContentPane().add(this.jScrollPaneTxtArea, BorderLayout.SOUTH);

        if (propertiesFilePath != null && propertiesFilePath.length() > 0) {
        	FileInputStream fis;
			try {
				fis = new FileInputStream(propertiesFilePath);
		        this.jaTSTester.loadJaTSTesterProperties(fis);
			} catch (Exception e1) {
				e1.printStackTrace();
				JOptionPane.showConfirmDialog(this,
						"Could not open properties file",
						"Error",
						JOptionPane.ERROR_MESSAGE);
			}
	        refreshComponentsSettings();
        }
		this.repaint();
		this.setVisible(true);
    }

  void menuItemEditProp_actionPerformed(ActionEvent e) {
        this.getContentPane().removeAll();
        this.getContentPane().add(this.panelEditProperties1, BorderLayout.CENTER);
        this.getContentPane().add(this.jScrollPaneTxtArea, BorderLayout.SOUTH);
        this.repaint();
        this.setVisible(true);
  }

  void menuItem1_actionPerformed(ActionEvent e) {
    this.getContentPane().removeAll();
    this.getContentPane().add(this.panelMetaProg, BorderLayout.CENTER);
    this.getContentPane().add(this.jScrollPaneTxtArea, BorderLayout.SOUTH);
    this.repaint();
    this.setVisible(true);
  }

}
