package cin.jats.tests.gui;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.util.Vector;
/**
 *  <p>
 *
 *  Title: </p> <p>
 *
 *  Description: </p> <p>
 *
 *  Copyright: Copyright (c) 2002</p> <p>
 *
 *  Company: </p>
 *
 *@author     Gustavo Santos
 *@created    March 20, 2003
 *@version    1.0
 */

public class PanelListFiles extends JPanel {
//    private final static String TEMPLATES_PATH = "C:\\qualiti_CVS\\QualitiCoder\\Utility\\JaTSTester\\testingFiles";
    Vector values = new Vector();

    JFileChooser fileChooser;
    javax.swing.filechooser.FileFilter filter;

    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanel1 = new JPanel();
    JPanel jPanel2 = new JPanel();
    JScrollPane jScrollPane1 = new JScrollPane();
    JList jListFiles = new JList();
    JButton jButtonRemove = new JButton();
    JButton jButtonAdd = new JButton();
    BorderLayout borderLayout2 = new BorderLayout();


    /**
     *  Constructor for the PanelListFiles object
     */
    public PanelListFiles() {
        try {
            jbInit();
            fileChooser = JaTSTesterFrame.fileChooser;
            filter = new javax.swing.filechooser.FileFilter() {
                     public boolean accept(File f) {
                       return f.getName().endsWith(".java")
                           || f.getName().endsWith(".jats")
                           || f.isDirectory();
                     }
                     public String getDescription() {
                       return "Transformation Files (*.java, *.jats)";
                     }
                  };

        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    /**
     *  Description of the Method
     *
     *@exception  Exception  Description of the Exception
     */
    private void jbInit() throws Exception {
        this.setLayout(borderLayout1);
        jButtonRemove.setText("Remove");
        jButtonRemove.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    jButtonRemove_actionPerformed(e);
                }
            });
        jButtonAdd.setMaximumSize(new Dimension(81, 27));
        jButtonAdd.setMinimumSize(new Dimension(81, 27));
        jButtonAdd.setPreferredSize(new Dimension(81, 27));
        jButtonAdd.setText("Add");
        jButtonAdd.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    jButtonAdd_actionPerformed(e);
                }
            });
        jPanel1.setLayout(borderLayout2);
        this.add(jPanel1, BorderLayout.CENTER);
        jPanel1.add(jScrollPane1, BorderLayout.CENTER);
        jScrollPane1.getViewport().add(jListFiles, null);
        this.add(jPanel2, BorderLayout.SOUTH);
        jPanel2.add(jButtonAdd, null);
        jPanel2.add(jButtonRemove, null);
    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void jButtonAdd_actionPerformed(ActionEvent e) {
        fileChooser.setMultiSelectionEnabled(true);
        fileChooser.setFileFilter(this.filter);
        int option = fileChooser.showOpenDialog(this);

        if (option == JFileChooser.APPROVE_OPTION) {
            File[] files = fileChooser.getSelectedFiles();
            this.fillFilesList(files);
        }
    }


    /**
     *  Description of the Method
     *
     *@param  files  Description of the Parameter
     */
    private void fillFilesList(File[] files) {
        //this.values = new Vector();

        if (files != null && files.length > 0) {
            for (int i = 0; i < files.length; i++) {
              if (!this.values.contains(files[i].getName()))
                values.add(files[i].getName());
            }
            this.jListFiles.setListData(this.values);
        }
    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void jButtonRemove_actionPerformed(ActionEvent e) {
        if (this.jListFiles.isSelectionEmpty()) {
            JOptionPane.showMessageDialog(this,
                    "Select a file on the list first", "Warnig",
                    JOptionPane.WARNING_MESSAGE);
        } else {
            Object[] files = this.jListFiles.getSelectedValues();

            for (int i = 0; i < files.length; i++) {
                this.values.remove(files[i]);
            }
            this.jListFiles.setListData(this.values);
        }
    }


    /**
     *  Gets the values attribute of the PanelListFiles object
     *
     *@return    The values value
     */
    public Vector getValues() {
        return values;
    }


    /**
     *  Sets the values attribute of the PanelListFiles object
     *
     *@param  values  The new values value
     */
    public void setValues(Vector values) {
        this.values = values;
        this.jListFiles.setListData(this.values);
    }

}
