package cin.jats.tests.gui;

import java.awt.*;
import javax.swing.*;

import cin.jats.tests.gui.DialogEditVar;
import cin.jats.tests.util.UserJaTSVariable;

import java.awt.event.*;
import java.util.Vector;

/**
 *  <p>
 *
 *  Title: </p> <p>
 *
 *  Description: </p> <p>
 *
 *  Copyright: Copyright (c) 2002</p> <p>
 *
 *  Company: </p>
 *
 *@author     Gustavo Santos
 *@created    24 de Maro de 2003
 *@version    1.0
 */

public class PanelListVar extends JPanel {
    private Vector variables = new Vector();

    BorderLayout borderLayout1 = new BorderLayout();
    JPanel jPanel1 = new JPanel();
    JPanel jPanel2 = new JPanel();
    JScrollPane jScrollPane1 = new JScrollPane();
    BorderLayout borderLayout2 = new BorderLayout();
    JList jList1 = new JList();
    GridLayout gridLayout1 = new GridLayout();
    JPanel jPanel3 = new JPanel();
    FlowLayout flowLayout1 = new FlowLayout();
    JButton jButtonAdd = new JButton();
    JPanel jPanel4 = new JPanel();
    JPanel jPanel5 = new JPanel();
    JButton jButtonEdit = new JButton();
    JButton jButtonRemove = new JButton();


    /**
     *  Constructor for the PanelListVar object
     */
    public PanelListVar() {
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    /**
     *  Description of the Method
     *
     *@exception  Exception  Description of the Exception
     */
    private void jbInit() throws Exception {
        this.setLayout(borderLayout1);
        jPanel1.setLayout(borderLayout2);
        jPanel2.setLayout(gridLayout1);
        gridLayout1.setColumns(1);
        gridLayout1.setHgap(10);
        gridLayout1.setRows(3);
        gridLayout1.setVgap(10);
        jPanel3.setLayout(flowLayout1);
        jButtonAdd.setPreferredSize(new Dimension(81, 27));
        jButtonAdd.setText("Add");
        jButtonAdd.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    jButtonAdd_actionPerformed(e);
                }
            });
        jButtonEdit.setPreferredSize(new Dimension(81, 27));
        jButtonEdit.setText("Edit");
        jButtonEdit.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    jButtonEdit_actionPerformed(e);
                }
            });
        jButtonRemove.setText("Remove");
        jButtonRemove.addActionListener(
            new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    jButtonRemove_actionPerformed(e);
                }
            });
        this.add(jPanel1, BorderLayout.CENTER);
        jPanel1.add(jScrollPane1, BorderLayout.CENTER);
        jScrollPane1.getViewport().add(jList1, null);
        this.add(jPanel2, BorderLayout.EAST);
        jPanel2.add(jPanel3, null);
        jPanel3.add(jButtonAdd, null);
        jPanel2.add(jPanel5, null);
        jPanel5.add(jButtonEdit, null);
        jPanel2.add(jPanel4, null);
        jPanel4.add(jButtonRemove, null);
    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void jButtonAdd_actionPerformed(ActionEvent e) {
        UserJaTSVariable var = null;
        DialogEditVar dialog = new DialogEditVar();
        int option = dialog.showDialog();

        if (option == DialogEditVar.APPROVE_OPTION) {
            var = dialog.getVariable();
            if (this.variables.contains(var)) {
                JOptionPane.showMessageDialog(this, "Variable already exists", "Error",
                        JOptionPane.ERROR_MESSAGE);
            } else {
                this.variables.addElement(var);
                this.jList1.setListData(this.variables);
            }
        }

    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void jButtonRemove_actionPerformed(ActionEvent e) {
        if (this.jList1.isSelectionEmpty()) {
            JOptionPane.showMessageDialog(this, "Select an element on the list",
                    "Warnig", JOptionPane.WARNING_MESSAGE);
        } else {
            UserJaTSVariable var = (UserJaTSVariable) this.jList1.getSelectedValue();
            this.variables.remove(var);
            this.jList1.setListData(this.variables);
        }
    }


    /**
     *  Description of the Method
     *
     *@param  e  Description of the Parameter
     */
    void jButtonEdit_actionPerformed(ActionEvent e) {
        if (this.jList1.isSelectionEmpty()) {
            JOptionPane.showMessageDialog(this, "Select an element on the list",
                    "Warnig", JOptionPane.WARNING_MESSAGE);
        } else {
            UserJaTSVariable var = (UserJaTSVariable) this.jList1.getSelectedValue();
            UserJaTSVariable temp = new UserJaTSVariable(var.getJatsTypeString(),
                    var.getJaTSVariableName(), var.getJaTSVariableValue());
            this.variables.remove(var);
            DialogEditVar dialog = new DialogEditVar(var);
            int option = dialog.showDialog();

            if (option == DialogEditVar.APPROVE_OPTION) {
                var = dialog.getVariable();
            } else {
                var = temp;
            }
            this.variables.addElement(var);
            this.jList1.setListData(this.variables);
        }

    }


    /**
     *  Gets the variables attribute of the PanelListVar object
     *
     *@return    The variables value
     */
    public Vector getVariables() {
        return variables;
    }


    /**
     *  Sets the variables attribute of the PanelListVar object
     *
     *@param  variables  The new variables value
     */
    public void setVariables(Vector variables) {
        this.variables = variables;
        this.jList1.setListData(this.variables);
    }

}
